#/bin/sh

if [ $# -ne 2 ]; then
    echo "moveframes.sh <src directory tree> <dst directory>"
    exit -1
fi

SRC=$1
DST=$2

if [ ! -d $SRC ]; then
    echo "ERROR: source directory $SRC not found."
    exit -1
fi

NUM_DPX_FILES=`find $SRC -name "*dpx" | wc -l`
NUM_ARI_FILES=`find $SRC -name "*ari" | wc -l`
let NUM_FILES=$NUM_DPX_FILES+$NUM_ARI_FILES
if [ $NUM_FILES -eq 0 ]; then
    echo "Nothing to do - no dpx/ari files found in $SRC."
    exit -1
fi

if [ ! -d $DST ]; then
    echo "ERROR: destination directory $DST not found."
    exit -1
fi

echo "Copying $NUM_FILES dpx files from $SRC to $DST..."
if [ $NUM_DPX_FILES -gt 0 ]; then
	find $SRC -name "*.dpx" -exec cp -i {} $DST \;
fi
if [ $NUM_ARI_FILES -gt 0 ]; then
	find $SRC -name "*.ari" -exec cp -i {} $DST \;
fi
echo "Done."
