# almgamate tape sections

# first line initialise
(NR==1) { 
    init=1;
};

/Event / {
    print $0;
    next;
}

/00000000a DUPE TAPE: / {
    tapes[++dupeCount] = $6;
    dupes[dupeCount] = $4;
    next;
}

function dump()
{
    if (dumped)
        return;

    if (firstmark)
    {
        if (firstmark != lastmark)
            cmd = lasttape " " firstmark " " lastmark; 
        else
            cmd = lasttape " " firstmark;
        if (firststartoffset > 0)
            cmd = cmd " -s " firststartoffset;
        if (lastendoffset)
            cmd = cmd " -e " lastendoffset;

        dupeTape = "";
        for (i=1; i<=dupeCount; i++)
        {
            if (tapes[i] == lasttape)
                dupeTape = dupes[i];
        }
        if (length(dupeTape))
            cmd = cmd " -d " dupeTape;

        if (length(prevtape))
            cmd = cmd " -l " prevtape;

        if (eventcount)
        {
            asort(events);
            cmd = cmd " (";
            for (i=1; i<=eventcount; i++)
            {
                if (i != 1)
                    cmd = cmd ",";
                cmd = cmd events[i];
            }
            cmd = cmd ")";
        }

        print cmd;
    }
    firstmark = $2;
    dumped = 1;
    eventcount=0;
    firststartoffset = -1;
    prevtape=lasttape;
    delete events;
}


# if this is a different tape then dump
$1 !~ lasttape {
    dump();
};

# if there is a jump in filemarks dump
$2 !~ lastmark+1 && $2 !~ lastmark { 
    dump();
};

# each line reset dump flag
(lastendoffset) {
    if ($2 != lastmark)
        dump();
};

(init) {
    eventcount=0;
    lasttape=$1; 
    firstmark=$2; 
    init = 0;
    firststartoffset = -1;
    lastmark = 0;
}

# update last variables each time
{
    startmark = $2;
    endmark = $2;
    start_offset = 0;
    end_offset = 0;

    error = 0;
    start_flag = 0;
    end_flag = 0;
    end_filemark_flag = 0;
    for (i=3; i<NF && !error; i++)
    {
        if ($i == "-s")
            start_flag = 1;
        else if ($i == "-e")
            end_flag = 1;
        else
        {
            if (start_flag)
            {
                start_offset = $i;
                start_flag = 0;
            }
            else if (end_flag)
            {
                end_offset = $i;
                end_flag = 0;
            }
            else if (!end_filemark_flag)
            {
                endmark = $i;
                end_filemark_flag = 1;
            }
            else
                error = 1;
        }
    }

    # if we've a start offset and there's stuff before this then
    # that needs dumping as its not contiguous with a start offset
    if (start_offset && lastmark)
    {
        if (startmark != lastmark)
            dump();
        else 
        {
           # if we have a start offset and its for the same chunk
           # as the last entry BUT it starts earlier in the chunk
           # then we have to update our start offset for this chunk
           if ((firststartoffset != -1) && (start_offset < firststartoffset))
              firststartoffset = start_offset;
        }    
    }

    # remember start offset of first mark if not set
    if (firststartoffset == -1)
        firststartoffset = start_offset;

    # store details of this filemark
    dumped = 0;
    event_already_registered = 0;
    for (i=1; i<=eventcount; i++)
    {
        if (events[i] == $NF+0)
            event_already_registered=1;
    }
    if (!event_already_registered)
        events[++eventcount] = $NF+0;
    lasttape = $1;
    laststartoffset = start_offset;

    # update last end offset unless this is the same end chunk
    # as the last entry and that had a later end point than this
    # (otherwise might delete frames required by earlier entry)
    if ( (lastmark != endmark) || (lastendoffset == -1) || 
                                   (end_offset < lastendoffset))
        lastendoffset = end_offset;
    lastmark = endmark;
}

# on the last line force a dump of that line
# it may have already dumped for previous values
END {
    dumped = 0;
    dump();
}

